unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs,ExtCtrls;

type
TInfo = class(TCustomControl)
 private
   FBlinki: boolean;
   FBlinkiText: string;
   FText      : string;
   FTextStyle : TTextStyle;
   BlinkiTimer: TTimer;
   FBlinkiFontColor : TColor;
   procedure SetBlinki(AValue: boolean);
   procedure setBlinkiText(AValue: string);
   procedure setText(AValue: string);
   procedure OnBlinkiTimer(Sender:TObject);
 public
   constructor Create(AOwner: TComponent); override;
   destructor Destroy; override;
   procedure   Paint; override;
   property Text : string read FText write setText;
   property BlinkiText : string read FBlinkiText write setBlinkiText;
   property Blinki: boolean read FBlinki write SetBlinki;

 end;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private

  public
    Info          : TInfo;
  end;

var
  Form1: TForm1;

implementation

uses LCLType;

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
 left := (Screen.DesktopWidth div 2) - (width div 2);

 Info             := TInfo.Create(self);
 Info.Parent      := self;
 Info.Left        := (width div 2) - (Info.Width div 2);
 Info.Top         :=  80;
 Info.Text        := 'TEST PROGRAMM';
 Info.BlinkiText  := 'Das ist ein blinkender Text';
 Info.Blinki      := true;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
 if (Key=VK_RETURN) then
  begin
   if assigned(Info) then FreeAndNil(Info);
  end;
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
 if (Key=VK_SPACE) then
  begin
   if assigned(Info) then FreeAndNil(Info);
  end;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if assigned(Info) then FreeAndNil(Info);
end;


{xxxxxxxxxxxxxxxxx TInfo xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx}

procedure TInfo.setText(AValue: string);
begin
  if FText=AValue then Exit;
  FText:=AValue;
end;

procedure TInfo.OnBlinkiTimer(Sender: TObject);
begin
 if FBlinkiFontColor = clFuchsia then
  FBlinkiFontColor     := $00323232 else
  FBlinkiFontColor     := clFuchsia;
  invalidate;
end;

procedure TInfo.setBlinkiText(AValue: string);
begin
  if FBlinkiText=AValue then Exit;
  FBlinkiText:=AValue;
end;

procedure TInfo.SetBlinki(AValue: boolean);
begin
  if FBlinki=AValue then Exit;
  FBlinki:=AValue;
  BlinkiTimer.Enabled:= FBlinki;
end;

constructor TInfo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  width := 500;
  height:= 300;
  FTextStyle.Clipping  := true;
  FTextStyle.Wordbreak := true;
  FTextStyle.SingleLine:= false;
  FTextStyle.Alignment := taCenter;
  FTextStyle.Layout    := tlCenter;

  BlinkiTimer          := TTimer.Create(nil); //hatte hier auch self
  BlinkiTimer.SetSubComponent(true);
  BlinkiTimer.Interval := 500;
  BlinkiTimer.Enabled  := false;
  BlinkiTimer.OnTimer  := @OnBlinkiTimer;
  FBlinkiFontColor     := clFuchsia;
end;

destructor TInfo.Destroy;
begin

  BlinkiTimer.Enabled  :=false;
  FreeAndNil(BlinkiTimer);//    BlinkiTimer.Free;
  inherited Destroy;
end;

procedure TInfo.Paint;
var lv : integer;
begin
  inherited Paint;

  Canvas.Brush.Color := $00323232;
  Canvas.Pen.Color   := clFuchsia;
  Canvas.FillRect(0,0,width,height);

  Canvas.Font.Color  := clFuchsia;
  Canvas.Font.Height:= 18;
  lv:=5;
  while lv<487 do
   begin
   Canvas.TextOut(lv,2,'*');
   inc(lv,12);
   end;
  lv:=14;
  while lv<275 do
   begin
   Canvas.TextOut(5,lv,'*');
   Canvas.TextOut(485,lv,'*');
   inc(lv,12);
   end;
  lv:=5;
  while lv<487 do
   begin
   Canvas.TextOut(lv,280,'*');
   inc(lv,12);
   end;

  Canvas.Font.Height:= 38;
  Canvas.TextRect(rect(0,0,width,200),0,0,FText,FTextStyle);

  Canvas.Font.Color:= FBlinkiFontColor;
  Canvas.Font.Height:= 28;
  Canvas.TextRect(rect(0,200,width,300),0,0,FBlinkiText,FTextStyle);
end;
//xxxxxxxxxxxxxxxxxxxx  TINFO ENDE xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx




end.

